git-rebase.shon commit Merge branch 'jc/merge-x-theirs-docfix' (4da3e23)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano.
   4#
   5
   6SUBDIRECTORY_OK=Yes
   7OPTIONS_KEEPDASHDASH=
   8OPTIONS_STUCKLONG=t
   9OPTIONS_SPEC="\
  10git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] [<upstream>] [<branch>]
  11git rebase [-i] [options] [--exec <cmd>] [--onto <newbase>] --root [<branch>]
  12git-rebase --continue | --abort | --skip | --edit-todo
  13--
  14 Available options are
  15v,verbose!         display a diffstat of what changed upstream
  16q,quiet!           be quiet. implies --no-stat
  17autostash          automatically stash/stash pop before and after
  18fork-point         use 'merge-base --fork-point' to refine upstream
  19onto=!             rebase onto given branch instead of upstream
  20p,preserve-merges! try to recreate merges instead of ignoring them
  21s,strategy=!       use the given merge strategy
  22no-ff!             cherry-pick all commits, even if unchanged
  23m,merge!           use merging strategies to rebase
  24i,interactive!     let the user edit the list of commits to rebase
  25x,exec=!           add exec lines after each commit of the editable list
  26k,keep-empty       preserve empty commits during rebase
  27f,force-rebase!    force rebase even if branch is up to date
  28X,strategy-option=! pass the argument through to the merge strategy
  29stat!              display a diffstat of what changed upstream
  30n,no-stat!         do not show diffstat of what changed upstream
  31verify             allow pre-rebase hook to run
  32rerere-autoupdate  allow rerere to update index with resolved conflicts
  33root!              rebase all reachable commits up to the root(s)
  34autosquash         move commits that begin with squash!/fixup! under -i
  35committer-date-is-author-date! passed to 'git am'
  36ignore-date!       passed to 'git am'
  37signoff            passed to 'git am'
  38whitespace=!       passed to 'git apply'
  39ignore-whitespace! passed to 'git apply'
  40C=!                passed to 'git apply'
  41S,gpg-sign?        GPG-sign commits
  42 Actions:
  43continue!          continue
  44abort!             abort and check out the original branch
  45skip!              skip current patch and continue
  46edit-todo!         edit the todo list during an interactive rebase
  47quit!              abort but keep HEAD where it is
  48"
  49. git-sh-setup
  50set_reflog_action rebase
  51require_work_tree_exists
  52cd_to_toplevel
  53
  54LF='
  55'
  56ok_to_skip_pre_rebase=
  57resolvemsg="
  58$(gettext 'Resolve all conflicts manually, mark them as resolved with
  59"git add/rm <conflicted_files>", then run "git rebase --continue".
  60You can instead skip this commit: run "git rebase --skip".
  61To abort and get back to the state before "git rebase", run "git rebase --abort".')
  62"
  63unset onto
  64unset restrict_revision
  65cmd=
  66strategy=
  67strategy_opts=
  68do_merge=
  69merge_dir="$GIT_DIR"/rebase-merge
  70apply_dir="$GIT_DIR"/rebase-apply
  71verbose=
  72diffstat=
  73test "$(git config --bool rebase.stat)" = true && diffstat=t
  74autostash="$(git config --bool rebase.autostash || echo false)"
  75fork_point=auto
  76git_am_opt=
  77git_format_patch_opt=
  78rebase_root=
  79force_rebase=
  80allow_rerere_autoupdate=
  81# Non-empty if a rebase was in progress when 'git rebase' was invoked
  82in_progress=
  83# One of {am, merge, interactive}
  84type=
  85# One of {"$GIT_DIR"/rebase-apply, "$GIT_DIR"/rebase-merge}
  86state_dir=
  87# One of {'', continue, skip, abort}, as parsed from command line
  88action=
  89preserve_merges=
  90autosquash=
  91keep_empty=
  92test "$(git config --bool rebase.autosquash)" = "true" && autosquash=t
  93case "$(git config --bool commit.gpgsign)" in
  94true)   gpg_sign_opt=-S ;;
  95*)      gpg_sign_opt= ;;
  96esac
  97
  98read_basic_state () {
  99        test -f "$state_dir/head-name" &&
 100        test -f "$state_dir/onto" &&
 101        head_name=$(cat "$state_dir"/head-name) &&
 102        onto=$(cat "$state_dir"/onto) &&
 103        # We always write to orig-head, but interactive rebase used to write to
 104        # head. Fall back to reading from head to cover for the case that the
 105        # user upgraded git with an ongoing interactive rebase.
 106        if test -f "$state_dir"/orig-head
 107        then
 108                orig_head=$(cat "$state_dir"/orig-head)
 109        else
 110                orig_head=$(cat "$state_dir"/head)
 111        fi &&
 112        GIT_QUIET=$(cat "$state_dir"/quiet) &&
 113        test -f "$state_dir"/verbose && verbose=t
 114        test -f "$state_dir"/strategy && strategy="$(cat "$state_dir"/strategy)"
 115        test -f "$state_dir"/strategy_opts &&
 116                strategy_opts="$(cat "$state_dir"/strategy_opts)"
 117        test -f "$state_dir"/allow_rerere_autoupdate &&
 118                allow_rerere_autoupdate="$(cat "$state_dir"/allow_rerere_autoupdate)"
 119        test -f "$state_dir"/gpg_sign_opt &&
 120                gpg_sign_opt="$(cat "$state_dir"/gpg_sign_opt)"
 121}
 122
 123write_basic_state () {
 124        echo "$head_name" > "$state_dir"/head-name &&
 125        echo "$onto" > "$state_dir"/onto &&
 126        echo "$orig_head" > "$state_dir"/orig-head &&
 127        echo "$GIT_QUIET" > "$state_dir"/quiet &&
 128        test t = "$verbose" && : > "$state_dir"/verbose
 129        test -n "$strategy" && echo "$strategy" > "$state_dir"/strategy
 130        test -n "$strategy_opts" && echo "$strategy_opts" > \
 131                "$state_dir"/strategy_opts
 132        test -n "$allow_rerere_autoupdate" && echo "$allow_rerere_autoupdate" > \
 133                "$state_dir"/allow_rerere_autoupdate
 134        test -n "$gpg_sign_opt" && echo "$gpg_sign_opt" > "$state_dir"/gpg_sign_opt
 135}
 136
 137output () {
 138        case "$verbose" in
 139        '')
 140                output=$("$@" 2>&1 )
 141                status=$?
 142                test $status != 0 && printf "%s\n" "$output"
 143                return $status
 144                ;;
 145        *)
 146                "$@"
 147                ;;
 148        esac
 149}
 150
 151move_to_original_branch () {
 152        case "$head_name" in
 153        refs/*)
 154                message="rebase finished: $head_name onto $onto"
 155                git update-ref -m "$message" \
 156                        $head_name $(git rev-parse HEAD) $orig_head &&
 157                git symbolic-ref \
 158                        -m "rebase finished: returning to $head_name" \
 159                        HEAD $head_name ||
 160                die "$(eval_gettext "Could not move back to \$head_name")"
 161                ;;
 162        esac
 163}
 164
 165apply_autostash () {
 166        if test -f "$state_dir/autostash"
 167        then
 168                stash_sha1=$(cat "$state_dir/autostash")
 169                if git stash apply $stash_sha1 2>&1 >/dev/null
 170                then
 171                        echo "$(gettext 'Applied autostash.')" >&2
 172                else
 173                        git stash store -m "autostash" -q $stash_sha1 ||
 174                        die "$(eval_gettext "Cannot store \$stash_sha1")"
 175                        gettext 'Applying autostash resulted in conflicts.
 176Your changes are safe in the stash.
 177You can run "git stash pop" or "git stash drop" at any time.
 178' >&2
 179                fi
 180        fi
 181}
 182
 183finish_rebase () {
 184        apply_autostash &&
 185        { git gc --auto || true; } &&
 186        rm -rf "$state_dir"
 187}
 188
 189run_specific_rebase () {
 190        if [ "$interactive_rebase" = implied ]; then
 191                GIT_EDITOR=:
 192                export GIT_EDITOR
 193                autosquash=
 194        fi
 195        . git-rebase--$type
 196        ret=$?
 197        if test $ret -eq 0
 198        then
 199                finish_rebase
 200        elif test $ret -eq 2 # special exit status for rebase -i
 201        then
 202                apply_autostash &&
 203                rm -rf "$state_dir" &&
 204                die "Nothing to do"
 205        fi
 206        exit $ret
 207}
 208
 209run_pre_rebase_hook () {
 210        if test -z "$ok_to_skip_pre_rebase" &&
 211           test -x "$(git rev-parse --git-path hooks/pre-rebase)"
 212        then
 213                "$(git rev-parse --git-path hooks/pre-rebase)" ${1+"$@"} ||
 214                die "$(gettext "The pre-rebase hook refused to rebase.")"
 215        fi
 216}
 217
 218test -f "$apply_dir"/applying &&
 219        die "$(gettext "It looks like git-am is in progress. Cannot rebase.")"
 220
 221if test -d "$apply_dir"
 222then
 223        type=am
 224        state_dir="$apply_dir"
 225elif test -d "$merge_dir"
 226then
 227        if test -f "$merge_dir"/interactive
 228        then
 229                type=interactive
 230                interactive_rebase=explicit
 231        else
 232                type=merge
 233        fi
 234        state_dir="$merge_dir"
 235fi
 236test -n "$type" && in_progress=t
 237
 238total_argc=$#
 239while test $# != 0
 240do
 241        case "$1" in
 242        --no-verify)
 243                ok_to_skip_pre_rebase=yes
 244                ;;
 245        --verify)
 246                ok_to_skip_pre_rebase=
 247                ;;
 248        --continue|--skip|--abort|--quit|--edit-todo)
 249                test $total_argc -eq 2 || usage
 250                action=${1##--}
 251                ;;
 252        --onto=*)
 253                onto="${1#--onto=}"
 254                ;;
 255        --exec=*)
 256                cmd="${cmd}exec ${1#--exec=}${LF}"
 257                test -z "$interactive_rebase" && interactive_rebase=implied
 258                ;;
 259        --interactive)
 260                interactive_rebase=explicit
 261                ;;
 262        --keep-empty)
 263                keep_empty=yes
 264                ;;
 265        --preserve-merges)
 266                preserve_merges=t
 267                test -z "$interactive_rebase" && interactive_rebase=implied
 268                ;;
 269        --autosquash)
 270                autosquash=t
 271                ;;
 272        --no-autosquash)
 273                autosquash=
 274                ;;
 275        --fork-point)
 276                fork_point=t
 277                ;;
 278        --no-fork-point)
 279                fork_point=
 280                ;;
 281        --merge)
 282                do_merge=t
 283                ;;
 284        --strategy-option=*)
 285                strategy_opts="$strategy_opts $(git rev-parse --sq-quote "--${1#--strategy-option=}")"
 286                do_merge=t
 287                test -z "$strategy" && strategy=recursive
 288                ;;
 289        --strategy=*)
 290                strategy="${1#--strategy=}"
 291                do_merge=t
 292                ;;
 293        --no-stat)
 294                diffstat=
 295                ;;
 296        --stat)
 297                diffstat=t
 298                ;;
 299        --autostash)
 300                autostash=true
 301                ;;
 302        --no-autostash)
 303                autostash=false
 304                ;;
 305        --verbose)
 306                verbose=t
 307                diffstat=t
 308                GIT_QUIET=
 309                ;;
 310        --quiet)
 311                GIT_QUIET=t
 312                git_am_opt="$git_am_opt -q"
 313                verbose=
 314                diffstat=
 315                ;;
 316        --whitespace=*)
 317                git_am_opt="$git_am_opt --whitespace=${1#--whitespace=}"
 318                case "${1#--whitespace=}" in
 319                fix|strip)
 320                        force_rebase=t
 321                        ;;
 322                esac
 323                ;;
 324        --ignore-whitespace)
 325                git_am_opt="$git_am_opt $1"
 326                ;;
 327        --committer-date-is-author-date|--ignore-date|--signoff|--no-signoff)
 328                git_am_opt="$git_am_opt $1"
 329                force_rebase=t
 330                ;;
 331        -C*)
 332                git_am_opt="$git_am_opt $1"
 333                ;;
 334        --root)
 335                rebase_root=t
 336                ;;
 337        --force-rebase|--no-ff)
 338                force_rebase=t
 339                ;;
 340        --rerere-autoupdate|--no-rerere-autoupdate)
 341                allow_rerere_autoupdate="$1"
 342                ;;
 343        --gpg-sign)
 344                gpg_sign_opt=-S
 345                ;;
 346        --gpg-sign=*)
 347                gpg_sign_opt="-S${1#--gpg-sign=}"
 348                ;;
 349        --)
 350                shift
 351                break
 352                ;;
 353        esac
 354        shift
 355done
 356test $# -gt 2 && usage
 357
 358if test -n "$action"
 359then
 360        test -z "$in_progress" && die "$(gettext "No rebase in progress?")"
 361        # Only interactive rebase uses detailed reflog messages
 362        if test "$type" = interactive && test "$GIT_REFLOG_ACTION" = rebase
 363        then
 364                GIT_REFLOG_ACTION="rebase -i ($action)"
 365                export GIT_REFLOG_ACTION
 366        fi
 367fi
 368
 369if test "$action" = "edit-todo" && test "$type" != "interactive"
 370then
 371        die "$(gettext "The --edit-todo action can only be used during interactive rebase.")"
 372fi
 373
 374case "$action" in
 375continue)
 376        # Sanity check
 377        git rev-parse --verify HEAD >/dev/null ||
 378                die "$(gettext "Cannot read HEAD")"
 379        git update-index --ignore-submodules --refresh &&
 380        git diff-files --quiet --ignore-submodules || {
 381                echo "$(gettext "You must edit all merge conflicts and then
 382mark them as resolved using git add")"
 383                exit 1
 384        }
 385        read_basic_state
 386        run_specific_rebase
 387        ;;
 388skip)
 389        output git reset --hard HEAD || exit $?
 390        read_basic_state
 391        run_specific_rebase
 392        ;;
 393abort)
 394        git rerere clear
 395        read_basic_state
 396        case "$head_name" in
 397        refs/*)
 398                git symbolic-ref -m "rebase: aborting" HEAD $head_name ||
 399                die "$(eval_gettext "Could not move back to \$head_name")"
 400                ;;
 401        esac
 402        output git reset --hard $orig_head
 403        finish_rebase
 404        exit
 405        ;;
 406quit)
 407        exec rm -rf "$state_dir"
 408        ;;
 409edit-todo)
 410        run_specific_rebase
 411        ;;
 412esac
 413
 414# Make sure no rebase is in progress
 415if test -n "$in_progress"
 416then
 417        state_dir_base=${state_dir##*/}
 418        cmd_live_rebase="git rebase (--continue | --abort | --skip)"
 419        cmd_clear_stale_rebase="rm -fr \"$state_dir\""
 420        die "
 421$(eval_gettext 'It seems that there is already a $state_dir_base directory, and
 422I wonder if you are in the middle of another rebase.  If that is the
 423case, please try
 424        $cmd_live_rebase
 425If that is not the case, please
 426        $cmd_clear_stale_rebase
 427and run me again.  I am stopping in case you still have something
 428valuable there.')"
 429fi
 430
 431if test -n "$rebase_root" && test -z "$onto"
 432then
 433        test -z "$interactive_rebase" && interactive_rebase=implied
 434fi
 435
 436if test -n "$interactive_rebase"
 437then
 438        type=interactive
 439        state_dir="$merge_dir"
 440elif test -n "$do_merge"
 441then
 442        type=merge
 443        state_dir="$merge_dir"
 444else
 445        type=am
 446        state_dir="$apply_dir"
 447fi
 448
 449if test -t 2 && test -z "$GIT_QUIET"
 450then
 451        git_format_patch_opt="$git_format_patch_opt --progress"
 452fi
 453
 454if test -z "$rebase_root"
 455then
 456        case "$#" in
 457        0)
 458                if ! upstream_name=$(git rev-parse --symbolic-full-name \
 459                        --verify -q @{upstream} 2>/dev/null)
 460                then
 461                        . git-parse-remote
 462                        error_on_missing_default_upstream "rebase" "rebase" \
 463                                "against" "git rebase $(gettext '<branch>')"
 464                fi
 465
 466                test "$fork_point" = auto && fork_point=t
 467                ;;
 468        *)      upstream_name="$1"
 469                if test "$upstream_name" = "-"
 470                then
 471                        upstream_name="@{-1}"
 472                fi
 473                shift
 474                ;;
 475        esac
 476        upstream=$(peel_committish "${upstream_name}") ||
 477        die "$(eval_gettext "invalid upstream \$upstream_name")"
 478        upstream_arg="$upstream_name"
 479else
 480        if test -z "$onto"
 481        then
 482                empty_tree=$(git hash-object -t tree /dev/null)
 483                onto=$(git commit-tree $empty_tree </dev/null)
 484                squash_onto="$onto"
 485        fi
 486        unset upstream_name
 487        unset upstream
 488        test $# -gt 1 && usage
 489        upstream_arg=--root
 490fi
 491
 492# Make sure the branch to rebase onto is valid.
 493onto_name=${onto-"$upstream_name"}
 494case "$onto_name" in
 495*...*)
 496        if      left=${onto_name%...*} right=${onto_name#*...} &&
 497                onto=$(git merge-base --all ${left:-HEAD} ${right:-HEAD})
 498        then
 499                case "$onto" in
 500                ?*"$LF"?*)
 501                        die "$(eval_gettext "\$onto_name: there are more than one merge bases")"
 502                        ;;
 503                '')
 504                        die "$(eval_gettext "\$onto_name: there is no merge base")"
 505                        ;;
 506                esac
 507        else
 508                die "$(eval_gettext "\$onto_name: there is no merge base")"
 509        fi
 510        ;;
 511*)
 512        onto=$(peel_committish "$onto_name") ||
 513        die "$(eval_gettext "Does not point to a valid commit: \$onto_name")"
 514        ;;
 515esac
 516
 517# If the branch to rebase is given, that is the branch we will rebase
 518# $branch_name -- branch being rebased, or HEAD (already detached)
 519# $orig_head -- commit object name of tip of the branch before rebasing
 520# $head_name -- refs/heads/<that-branch> or "detached HEAD"
 521switch_to=
 522case "$#" in
 5231)
 524        # Is it "rebase other $branchname" or "rebase other $commit"?
 525        branch_name="$1"
 526        switch_to="$1"
 527
 528        if git show-ref --verify --quiet -- "refs/heads/$1" &&
 529           orig_head=$(git rev-parse -q --verify "refs/heads/$1")
 530        then
 531                head_name="refs/heads/$1"
 532        elif orig_head=$(git rev-parse -q --verify "$1")
 533        then
 534                head_name="detached HEAD"
 535        else
 536                die "$(eval_gettext "fatal: no such branch: \$branch_name")"
 537        fi
 538        ;;
 5390)
 540        # Do not need to switch branches, we are already on it.
 541        if branch_name=$(git symbolic-ref -q HEAD)
 542        then
 543                head_name=$branch_name
 544                branch_name=$(expr "z$branch_name" : 'zrefs/heads/\(.*\)')
 545        else
 546                head_name="detached HEAD"
 547                branch_name=HEAD ;# detached
 548        fi
 549        orig_head=$(git rev-parse --verify HEAD) || exit
 550        ;;
 551*)
 552        die "BUG: unexpected number of arguments left to parse"
 553        ;;
 554esac
 555
 556if test "$fork_point" = t
 557then
 558        new_upstream=$(git merge-base --fork-point "$upstream_name" \
 559                        "${switch_to:-HEAD}")
 560        if test -n "$new_upstream"
 561        then
 562                restrict_revision=$new_upstream
 563        fi
 564fi
 565
 566if test "$autostash" = true && ! (require_clean_work_tree) 2>/dev/null
 567then
 568        stash_sha1=$(git stash create "autostash") ||
 569        die "$(gettext 'Cannot autostash')"
 570
 571        mkdir -p "$state_dir" &&
 572        echo $stash_sha1 >"$state_dir/autostash" &&
 573        stash_abbrev=$(git rev-parse --short $stash_sha1) &&
 574        echo "$(eval_gettext 'Created autostash: $stash_abbrev')" &&
 575        git reset --hard
 576fi
 577
 578require_clean_work_tree "rebase" "$(gettext "Please commit or stash them.")"
 579
 580# Now we are rebasing commits $upstream..$orig_head (or with --root,
 581# everything leading up to $orig_head) on top of $onto
 582
 583# Check if we are already based on $onto with linear history,
 584# but this should be done only when upstream and onto are the same
 585# and if this is not an interactive rebase.
 586mb=$(git merge-base "$onto" "$orig_head")
 587if test "$type" != interactive && test "$upstream" = "$onto" &&
 588        test "$mb" = "$onto" && test -z "$restrict_revision" &&
 589        # linear history?
 590        ! (git rev-list --parents "$onto".."$orig_head" | sane_grep " .* ") > /dev/null
 591then
 592        if test -z "$force_rebase"
 593        then
 594                # Lazily switch to the target branch if needed...
 595                test -z "$switch_to" ||
 596                GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to" \
 597                        git checkout -q "$switch_to" --
 598                say "$(eval_gettext "Current branch \$branch_name is up to date.")"
 599                finish_rebase
 600                exit 0
 601        else
 602                say "$(eval_gettext "Current branch \$branch_name is up to date, rebase forced.")"
 603        fi
 604fi
 605
 606# If a hook exists, give it a chance to interrupt
 607run_pre_rebase_hook "$upstream_arg" "$@"
 608
 609if test -n "$diffstat"
 610then
 611        if test -n "$verbose"
 612        then
 613                echo "$(eval_gettext "Changes from \$mb to \$onto:")"
 614        fi
 615        # We want color (if set), but no pager
 616        GIT_PAGER='' git diff --stat --summary "$mb" "$onto"
 617fi
 618
 619test "$type" = interactive && run_specific_rebase
 620
 621# Detach HEAD and reset the tree
 622say "$(gettext "First, rewinding head to replay your work on top of it...")"
 623
 624GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name" \
 625        git checkout -q "$onto^0" || die "could not detach HEAD"
 626git update-ref ORIG_HEAD $orig_head
 627
 628# If the $onto is a proper descendant of the tip of the branch, then
 629# we just fast-forwarded.
 630if test "$mb" = "$orig_head"
 631then
 632        say "$(eval_gettext "Fast-forwarded \$branch_name to \$onto_name.")"
 633        move_to_original_branch
 634        finish_rebase
 635        exit 0
 636fi
 637
 638if test -n "$rebase_root"
 639then
 640        revisions="$onto..$orig_head"
 641else
 642        revisions="${restrict_revision-$upstream}..$orig_head"
 643fi
 644
 645run_specific_rebase